/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/ProvideMeterDataRequest.java-arc   1.8   Sep 15 2005 11:25:08   adij  $
 * $Revision:   1.8  $
 * $Date:   Sep 15 2005 11:25:08  $
 *
 * Copyright 2005 Capgemini Australia Pty. Ltd.
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb;

import java.util.List;

import com.capgemini.nemmco.b2bb.enums.TransactionType;
import com.capgemini.nemmco.b2bb.exceptions.UnableToLookupResourceException;
import com.capgemini.nemmco.b2bb.lookup.B2BParticipantRole;
import com.capgemini.nemmco.b2bb.utils.B2BDateFormatter;

/**
 * Defines the provide meter data request transaction
 * a code
 *
 * @author $Author:   adij  $
 * @version $Revision:   1.8  $ $Date:   Sep 15 2005 11:25:08  $
 */
public class ProvideMeterDataRequest extends Transaction {
  public static String END_READ_DATE = "endReadDate";
  public static String NMI = "NMI";
  public static String NMI_CHECKSUM = "NMIChecksum";
  public static String PARTICIPANT_ROLE = "participantRole";        
  public static String START_READ_DATE = "startReadDate";
  
  private String endReadDate = "";
  private boolean endReadDateSet;
  private String endReadDisplayDate = "";
  private String nmi = "";
  private String NMIChecksum = "";
  private String participantRole = "";
  private String startReadDate = "";
  private boolean startReadDateSet;
  private String startReadDisplayDate = "";

/**
 * Default constructor
 */
  public ProvideMeterDataRequest() {
    super(TransactionType.PROVIDE_METER_DATA_REQ);
  }

/**
   * 
   * @return returns the endReadDate
   */
  public String getEndReadDate() {
    return endReadDate;
  }

/**
   * 
   * @return returns the endReadDisplayDate
   */
  public String getEndReadDisplayDate() {
    return endReadDisplayDate;
  }

/**
   * 
   * @return returns the NMI
   */
  public String getNMI() {
    return nmi;
  }

/**
   * 
   * @return returns the NMIChecksum
   */
  public String getNMIChecksum() {
    return NMIChecksum;
  }

/**
   *
   * @return returns the participantRole
   */
  public String getParticipantRole() {
    return participantRole;
  }

/**
   * 
   * @return returns the list of participantRoles
   * @throws UnableToLookupResourceException 
   */
  public List<Object> getRoles() throws UnableToLookupResourceException {
    return B2BParticipantRole.getList();
  }

/**
   * 
   * @return return the startReadDate
   */
  public String getStartReadDate() {
    return startReadDate;
  }

/**
   * 
   * @return returns the startReadDisplayDate
   */
  public String getStartReadDisplayDate() {
    return startReadDisplayDate;
  }

  /**
   * 
   * @param endReadDate
   */
  public void setEndReadDate(String endReadDate) {
    this.endReadDateSet = true;
    this.endReadDate = endReadDate;
    try {
      B2BDateFormatter df = new B2BDateFormatter(endReadDate, B2BDateFormatter.XMLDATE);
      this.endReadDisplayDate = df.getB2BDate();
    } catch (Exception e) {

      this.endReadDisplayDate = "";
    }
  }

  /**
   * 
   * @param endReadDisplayDate
   */
  public void setEndReadDisplayDate(String endReadDisplayDate) {
    this.endReadDateSet = false;
    this.endReadDisplayDate = endReadDisplayDate;
    try {
      B2BDateFormatter df = new B2BDateFormatter(endReadDisplayDate, B2BDateFormatter.B2BDATE);
      this.endReadDate = df.getXMLDate();
    } catch (Exception e) {
      this.endReadDate = "";
    }
  }

  /**
   * 
   * @param NMI The NMI to set
   */
  public void setNMI(String NMI) {
    this.nmi = NMI;
  }

  /**
   * 
   * @param NMIChecksum The NMIChecksum to set
   */
  public void setNMIChecksum(String NMIChecksum) {
    this.NMIChecksum = NMIChecksum;
  }

  /**
   * 
   * @param participantRole The participantRole to set
   */
  public void setParticipantRole(String participantRole) {
    this.participantRole = participantRole;
  }

  /**
   * 
   * @param startReadDate The startReadDate to set
   */
  public void setStartReadDate(String startReadDate) {
    this.startReadDateSet = true;
    this.startReadDate = startReadDate;
    try {
      B2BDateFormatter df = new B2BDateFormatter(startReadDate, B2BDateFormatter.XMLDATE);
      this.startReadDisplayDate = df.getB2BDate();
    } catch (Exception e) {
      this.startReadDisplayDate = "";
    }
  }

  /**
   * 
   * @param startReadDisplayDate The startReadDisplayDate to set
   */
  public void setStartReadDisplayDate(String startReadDisplayDate) {

    this.startReadDateSet = false;
    this.startReadDisplayDate = startReadDisplayDate;
    try {
      B2BDateFormatter df = new B2BDateFormatter(startReadDisplayDate, B2BDateFormatter.B2BDATE);
      this.startReadDate = df.getXMLDate();
    } catch (Exception e) {
      this.startReadDate = "";
    }
  }

  /**
   * 
   * @return returns true if startReadDate is set, false otherwise
   */
  public boolean isStartReadDateSet() {
    return startReadDateSet;
  }
  
  /**
   * 
   * @param startReadDateSet The startReadDateSet to set
   */
  public void setStartReadDateSet(boolean startReadDateSet) {
    this.startReadDateSet = startReadDateSet;
  }
  
  /**
   * 
   * @return returns true if endReadDate is set, false otherwise
   */
  public boolean isEndReadDateSet() {
    return endReadDateSet;
  }
  
  /**
   * 
   * @param endReadDateSet The endReadDateSet to set
   */
  public void setEndReadDateSet(boolean endReadDateSet) {
    this.endReadDateSet = endReadDateSet;
  }
}

