/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/ActionType.java-arc   1.5   08 Apr 2005 14:23:34   RayanS  $
 * $Revision:   1.5  $
 * $Date:   08 Apr 2005 14:23:34  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;
    
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.5  $ $Date:   08 Apr 2005 14:23:34  $
 */

public class ActionType extends Enumeration 
                        implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
  
    /**
		  * The following define the enumerations.
		  */
    public static final ActionType NEW     = new ActionType("New", "New");
    public static final ActionType CANCEL  = new ActionType("Cancel", "Cancel");
    public static final ActionType REPLACE = new ActionType("Replace", "Replace");

    private static final ActionType[] ACTION_TYPE_ARRAY =
      { NEW,
        CANCEL,
        REPLACE
      };

    public static final List<? extends Object> ACTION_TYPE_CODES =
      Collections.unmodifiableList(Arrays.asList(ACTION_TYPE_ARRAY));

    private ActionType(String code, 
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }


    public String toString() {
      return code + "-" + description;
    }

}

