/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/ActivityAction.java-arc   1.3   19 Apr 2005 14:12:50   hendyl  $
 * $Revision:   1.3  $
 * $Date:   19 Apr 2005 14:12:50  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed  Changed By     Comments
 * ------------  ----------     --------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */
 
package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration for B2B Activity action.
 *
 * @author $Author:   hendyl  $
 * @version $Revision:   1.3  $ $Date:   19 Apr 2005 14:12:50  $
 */
public class ActivityAction extends Enumeration 
implements Comparable<Object>, java.io.Serializable
{
    /**
		  * The following define the enumerations.
		  */
    public static final ActivityAction UPLOAD_FILE     = new ActivityAction("Upload File", "Upload File");
    public static final ActivityAction CREATE_TRANSACTION  = new ActivityAction("Create Transaction", "Create Transaction");
    public static final ActivityAction CREATE_ACKNOWLEDGEMENT = new ActivityAction("Create Acknowledgement", "Create Acknowledgement");
    public static final ActivityAction DELETE_FILE = new ActivityAction("Delete File", "Delete File");
    public static final ActivityAction DOWNLOAD_FILE = new ActivityAction("Download File", "Download File");
    public static final ActivityAction AUTO_DELETE_ON = new ActivityAction("Auto Delete On", "Auto Delete On");
    public static final ActivityAction AUTO_DELETE_OFF = new ActivityAction("Auto Delete Off", "Auto Delete Off");
    public static final ActivityAction TOGGLE_MOD_FUNCTIONALITY_ON = new ActivityAction("Toggle Modify Functionality On", "Toggle Modify Functionality On");
    public static final ActivityAction TOGGLE_MOD_FUNCTIONALITY_OFF = new ActivityAction("Toggle Modify Functionality Off", "Toggle Modify Functionality Off");
    public static final ActivityAction SEARCH_TRANSACTION_LOG = new ActivityAction("Search Transaction Log", "Search Transaction Log");
    public static final ActivityAction VIEW_B2B_HUB_DASHBOARD = new ActivityAction("View B2B Hub Dashboard", "View B2B Hub Dashboard");
    public static final ActivityAction VIEW_FLOW_CONTROL_DATA = new ActivityAction("View Flow Control Data", "View Flow Control Data");

	public static final ActivityAction UPLOAD_FILE_FTP = new ActivityAction("Upload File FTP", "Upload File FTP");
    public static final ActivityAction UPLOAD_FILE_HUB = new ActivityAction("Upload File HUB", "Upload File HUB");
    public static final ActivityAction CREATE_TRANSACTION_FTP = new ActivityAction("Create Transaction FTP", "Create Transaction FTP");
    public static final ActivityAction CREATE_TRANSACTION_HUB = new ActivityAction("Create Transaction Hub", "Create Transaction Hub");
    private static int count = 0;    

    private static final ActivityAction[] ACTIVITY_ACTION_ARRAY =
      { 
        AUTO_DELETE_OFF,
        AUTO_DELETE_ON,
        CREATE_ACKNOWLEDGEMENT,
        CREATE_TRANSACTION,
        CREATE_TRANSACTION_FTP,
        CREATE_TRANSACTION_HUB,
        DELETE_FILE,
        DOWNLOAD_FILE,
        SEARCH_TRANSACTION_LOG,
        TOGGLE_MOD_FUNCTIONALITY_ON,
        TOGGLE_MOD_FUNCTIONALITY_OFF,
        UPLOAD_FILE,
        UPLOAD_FILE_FTP,
        UPLOAD_FILE_HUB,
        VIEW_B2B_HUB_DASHBOARD,
        VIEW_FLOW_CONTROL_DATA
      };

    public static final List<? extends Object> ACTIVITY_ACTION_CODES =
      Collections.unmodifiableList(Arrays.asList(ACTIVITY_ACTION_ARRAY));

    private ActivityAction(String code, 
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }


    public String toString() {
      return code + "-" + description;
    }

}