/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/ConcessionCardRebateCode.java-arc   1.3   15 Apr 2005 14:11:10   hendyl  $
 * $Revision:   1.3  $
 * $Date:   15 Apr 2005 14:11:10  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 * Immutable, Thread safe, and resolves properly on deserialization.
 * 
 * @author $Author:   hendyl  $
 * @version $Revision:   1.3  $ $Date:   15 Apr 2005 14:11:10  $
 */

public class ConcessionCardRebateCode extends Enumeration 
                           implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
  
	/**
	 * The following define the enumerations.
	 */
   public static final ConcessionCardRebateCode PENSION_CARD        = new ConcessionCardRebateCode("Pension Card", "Pension Card");
	 public static final ConcessionCardRebateCode HEALTH_CARE_CARD    = new ConcessionCardRebateCode("Health Care Card" , "Health Care Card");
   public static final ConcessionCardRebateCode HEALTH_BENIFIT_CARD = new ConcessionCardRebateCode("Health Benefit Card" , "Health Benefit Card");
   public static final ConcessionCardRebateCode VERTERN_AFFAIR_CARD = new ConcessionCardRebateCode("Veteran Affairs Card" , "Veteran Affairs Card");

    private static final ConcessionCardRebateCode[] REBATE_CODE_ARRAY =
      {
        PENSION_CARD,
        HEALTH_CARE_CARD,
        HEALTH_BENIFIT_CARD,
        VERTERN_AFFAIR_CARD
      };

    public static final List<? extends Object> REBATE_CODES =
      Collections.unmodifiableList(Arrays.asList(REBATE_CODE_ARRAY));

    private ConcessionCardRebateCode(String code, 
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }

}

