/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/CustomerType.java-arc   1.3   08 Apr 2005 14:23:36   RayanS  $
 * $Revision:   1.3  $
 * $Date:   08 Apr 2005 14:23:36  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.3  $ $Date:   08 Apr 2005 14:23:36  $
 */

public class CustomerType extends Enumeration 
                         implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
    /**
		  * The following define the enumerations.
		  */

    public static final CustomerType INDUSTRIAL  = new CustomerType("Industrial", "Industrial");
    public static final CustomerType COMMERCIAL  = new CustomerType("Commercial", "Commercial");
    public static final CustomerType RESIDENTIAL = new CustomerType("Residential", "Residential");
    public static final CustomerType FARM        = new CustomerType("Farm", "Farm");
    public static final CustomerType LIGHTING    = new CustomerType("Lighting", "Lighting");
    
    private static final CustomerType[] CUSTOMER_TYPE_ARRAY =
      { INDUSTRIAL,
		    COMMERCIAL,
		    RESIDENTIAL,
		    FARM,
		    LIGHTING
      };

    public static final List<? extends Object> CUSTOMER_TYPES =
      Collections.unmodifiableList(Arrays.asList(CUSTOMER_TYPE_ARRAY));

    private CustomerType(String code, 
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }

}

