/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/InvestigationCode.java-arc   1.3   08 Apr 2005 14:23:40   RayanS  $
 * $Revision:   1.3  $
 * $Date:   08 Apr 2005 14:23:40  $
 *
 * Copyright 2005 Capgemini Australia Pty. Ltd.
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7.
 * 27-Jun-2017    Harpreet Kaur  7135 Package7B Added and removed new dropdown options for InvestigationCode in VerifyMeterDataRequest
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.3  $ $Date:   08 Apr 2005 14:23:40  $
 */

public class DeEnergisationReason extends Enumeration
                               implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;

    /**
		  * The following define the enumerations.
		  */
    public static final DeEnergisationReason CUSTOMER_REQUESTED = new DeEnergisationReason("Customer Requested","Customer Requested");
    public static final DeEnergisationReason MOVE_OUT      = new DeEnergisationReason("Move Out","Move Out");
    public static final DeEnergisationReason NON_PAYMENT               = new DeEnergisationReason("Non-Payment (DNP)", "Non-Payment (DNP)");
    public static final DeEnergisationReason UNAUTHORISED_USAGE             = new DeEnergisationReason("Unauthorised Usage (DNI)", "Unauthorised Usage (DNI)");
    public static final DeEnergisationReason ILLEGAL_USAGE         = new DeEnergisationReason("Illegal Usage", "Illegal Usage");
    public static final DeEnergisationReason NO_ACCESS                   = new DeEnergisationReason("No Access", "No Access");
    public static final DeEnergisationReason SAFETY            = new DeEnergisationReason("Safety", "Safety");
    public static final DeEnergisationReason DEFECT  = new DeEnergisationReason("Defect", "Defect");
    public static final DeEnergisationReason SITE_WORKS         = new DeEnergisationReason("Site Works", "Site Works");
    public static final DeEnergisationReason BREACH_OF_CONTRACT      = new DeEnergisationReason("Breach of Contract", "Breach of Contract");
    public static final DeEnergisationReason OTHER    = new DeEnergisationReason("Other", "Other");

    private static final DeEnergisationReason[] DEENERGISATION_REASON_ARRAY =
      { CUSTOMER_REQUESTED,
        MOVE_OUT,
        NON_PAYMENT,
        UNAUTHORISED_USAGE,
        ILLEGAL_USAGE,
        NO_ACCESS,
        SAFETY,
        DEFECT,
        SITE_WORKS,
        BREACH_OF_CONTRACT,
        OTHER
      };

    public static final List<? extends Object> DEENERGISATION_REASON =
      Collections.unmodifiableList(Arrays.asList(DEENERGISATION_REASON_ARRAY));

    private DeEnergisationReason(String code,
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }


    public String toString() {
      return code + "-" + description;
    }

}

