/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/EventClass.java-arc   1.4   11 Apr 2005 11:10:44   RayanS  $
 * $Revision:   1.4  $
 * $Date:   11 Apr 2005 11:10:44  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7. 
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.4  $ $Date:   11 Apr 2005 11:10:44  $
 */
public class EventClass extends Enumeration implements Comparable<Object>, java.io.Serializable {
  // Public constants
  private static int count = 0;

  /**
   * The following define the enumerations.
   */
  public static final EventClass APPLICATION = new EventClass("Application", "Application");
  public static final EventClass PROCESSING = new EventClass("Processing", "Processing");
  public static final EventClass MESSAGE = new EventClass("Message", "Message");

  private static final EventClass[] EVENT_CLASS_ARRAY = { APPLICATION, PROCESSING, MESSAGE };

  public static final List<? extends Object> EVENT_CLASSES = Collections.unmodifiableList(Arrays.asList(EVENT_CLASS_ARRAY));

  /**
   * Return the EventClass object given by code (key)
   * 
   * @param code The code to find in this enumeration
   * @return The object associated with the key. Null otherwise
   */
  public static EventClass getEventClass(String code) {
    for (int i = 0; i < EVENT_CLASSES.size(); i++) {
      if ((((Enumeration) EVENT_CLASSES.get(i)).getCode()).equals(code))
          return (EventClass) EVENT_CLASSES.get(i);
    }
    return null;
  }
  
  private EventClass(String code, String description) {
    this.code = code;
    this.description = description;
    this.number = ++count;
  }
}

