/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/FloorOrLevelType.java-arc   1.2   15 Apr 2005 14:11:34   hendyl  $
 * $Revision:   1.2  $
 * $Date:   15 Apr 2005 14:11:34  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * 
 * Modification History
 *
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 20-Jan-2006    Eddie Graham      Defect 3698 - Add LEVEL.
 * 04-Jul-2011    Eddie Graham      Defect 7366. Derive enumerations from aseXML Enumerations schema file.
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import com.sun.xml.xsom.XSFacet;
import com.sun.xml.xsom.XSRestrictionSimpleType;
import com.sun.xml.xsom.XSSchema;

import com.sun.xml.xsom.XSSimpleType;

import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

/**
 * Defines the Enumeration
 *
 * @author $Author:   hendyl  $
 * @version $Revision:   1.2  $ $Date:   15 Apr 2005 14:11:34  $
 */

public class FloorOrLevelType extends Enumeration 
                            implements Comparable<Object>, java.io.Serializable {
	// Public constants
   private static int count = 0;

   public static List<? extends Object> FLOOR_OR_LEVEL_TYPES;  
 
   public static void setFloorOrLevelType(XSSchema xsSchema) {
      FloorOrLevelType[] floorOrLevelType = null;    
   
      XSSimpleType st = xsSchema.getSimpleType("AustralianFloorOrLevelType");     

      if(st != null){         
         XSRestrictionSimpleType restriction = st.asRestriction();
         
         if(restriction != null){
            Vector<FloorOrLevelType> enumeration = new Vector<FloorOrLevelType>();         
            Iterator<? extends XSFacet> i = restriction.getDeclaredFacets().iterator();
            while(i.hasNext()){
               XSFacet facet = (XSFacet)i.next();
               if(facet.getName().equals(XSFacet.FACET_ENUMERATION)){             
                  enumeration.add(new FloorOrLevelType(facet.getValue().value,facet.getValue().value));
               }
            }
         
            if(enumeration.size() > 0){
               floorOrLevelType = enumeration.toArray(new FloorOrLevelType[]{});
               Arrays.sort(floorOrLevelType);               
               FLOOR_OR_LEVEL_TYPES = Collections.unmodifiableList(Arrays.asList(floorOrLevelType));            
            }
         }      
      }
   } 

   private FloorOrLevelType(String code, 
                 String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
   }

   public String toString() {
      return code + "-" + description;
   }
}

