/*
 * GenerationType.java
 *
 * The Copyright of this work is vested in the Australian Energy Market
 * Operator (AEMO) and the software is issued in confidence for the purpose
 * only for which it is supplied. It must not be reproduced in whole or in
 * part or used for tendering or manufacturing purposes except under an
 * agreement or with the consent in writing of AEMO and then only on the
 * condition that this notice is included in any such reproduction.
 * No information as to the contents or subject matter of this software or
 * any part thereof arising directly or indirectly there from shall be
 * given orally or in writing or communicated in any manner whatsoever to
 * any third party being an individual firm or company or any employee
 * thereof without the prior consent in writing of AEMO.
 *
 * Copyright Australian Energy Market Operator Limited. 2017
 *
 * Modification History
 *
 * Date Changed   Changed By       Description
 * ------------   ----------       -----------
 * 11-Jul-2017    SP                Created as part of the SMP new screens
 */
package com.capgemini.nemmco.b2bb.enums;

import java.io.Serializable;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class GenerationType extends Enumeration implements Comparable<Object>, Serializable {
   // Public constants
   private static int count = 0;

    /**
        * The following define the enumerations.
        */
    public static final GenerationType NET           = new GenerationType("Net", "Net");
    public static final GenerationType GROSS     = new GenerationType("Gross", "Gross");
    public static final GenerationType NONE = new GenerationType("None", "None");


    private static final GenerationType[] GENERATION_TYPE_ARRAY =
      { NET,
        GROSS,
         NONE
      };

    public static final List<? extends Object> GENERATION_TYPES =
      Collections.unmodifiableList(Arrays.asList(GENERATION_TYPE_ARRAY));

    private GenerationType(String code,
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }
}
