/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/InstallationType.java-arc   1.3   08 Apr 2005 14:23:40   RayanS  $
 * $Revision:   1.3  $
 * $Date:   08 Apr 2005 14:23:40  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.3  $ $Date:   08 Apr 2005 14:23:40  $
 */

public class InstallationType extends Enumeration 
                              implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
  
    /**
		  * The following define the enumerations.
		  */
    public static final InstallationType UNDERGROUND              = new InstallationType("Underground", "Underground");
    public static final InstallationType OVERHEAD                 = new InstallationType("Overhead", "Overhead");
    public static final InstallationType UNDERGROUND_TO_OVERHEAD  = new InstallationType("Underground To Overhead Mains", "Underground To Overhead Mains");
    public static final InstallationType OVERHEAD_TO_UNDERGROUND  = new InstallationType("Overhead To Underground Mains", "Overhead To Underground Mains");
    public static final InstallationType TRANSFORMER_OVERHEAD     = new InstallationType("Transformer Overhead", "Transformer Overhead");
    public static final InstallationType TRANSFORMER_GROUND_LEVEL = new InstallationType("Transformer Ground Level", "Transformer Ground Level");

    
    private static final InstallationType[] INSTALLATION_TYPE_ARRAY =
      { UNDERGROUND,
        OVERHEAD,
        UNDERGROUND_TO_OVERHEAD,
        OVERHEAD_TO_UNDERGROUND,
        TRANSFORMER_OVERHEAD,
        TRANSFORMER_GROUND_LEVEL
      };

    public static final List<? extends Object> INSTALLATION_TYPES =
      Collections.unmodifiableList(Arrays.asList(INSTALLATION_TYPE_ARRAY));

    private InstallationType(String code, 
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }


    public String toString() {
      return code + "-" + description;
    }

}

