/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/MessageStatus.java-arc   1.0   May 02 2005 17:53:28   adij  $
 * $Revision:   1.0  $
 * $Date:   May 02 2005 17:53:28  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the priority Enumeration
 *
 * @author $Author:   adij  $
 * @version $Revision:   1.0  $ $Date:   May 02 2005 17:53:28  $
 */
public class MessageStatus extends Enumeration implements Comparable<Object>, java.io.Serializable {
  // Public constants
  private static int count = 0;

  /**
   * The following define the Transaction Type enumerations.
   */
  public static final MessageStatus ACCEPT = new MessageStatus("Accept", "Accept");
  public static final MessageStatus REJECT = new MessageStatus("Reject", "Reject");

  private static final MessageStatus[] STATUS_TYPE_ARRAY = { ACCEPT, REJECT };

  public static final List<? extends Object> STATUSES = Collections.unmodifiableList(Arrays.asList(STATUS_TYPE_ARRAY));

  private MessageStatus(String code, String description) {
    this.code = code;
    this.description = description;
    this.number = ++count;
  }
  
  /**
   * Return the Status object given by code (key)
   * 
   * @param code
   *          The key to find in this enumeration
   * @return The object associated with the key. Null otherwise
   */
  public static MessageStatus getStatus(String code) {
    for (int i = 0; i < STATUSES.size(); i++) {
      if ((((Enumeration) STATUSES.get(i)).getCode()).equals(code))
          return (MessageStatus) STATUSES.get(i);
    }
    return null;
  }
}

