/*
 * MeterFaultAndIssueReasons.java
 *
 * The Copyright of this work is vested in the Australian Energy Market
 * Operator (AEMO) and the software is issued in confidence for the purpose
 * only for which it is supplied. It must not be reproduced in whole or in
 * part or used for tendering or manufacturing purposes except under an
 * agreement or with the consent in writing of AEMO and then only on the
 * condition that this notice is included in any such reproduction.
 * No information as to the contents or subject matter of this software or
 * any part thereof arising directly or indirectly there from shall be
 * given orally or in writing or communicated in any manner whatsoever to
 * any third party being an individual firm or company or any employee
 * thereof without the prior consent in writing of AEMO.
 *
 * Copyright Australian Energy Market Operator Limited. 2017
 *
 * Modification History
 *
 * Date Changed   Changed By        Description
 * ------------   ----------        -----------
 * 10-Jul-2017    Harpreet Kaur     Created
 */


package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class MeterFaultAndIssueReasons extends Enumeration implements Comparable<Object>, java.io.Serializable {
   // Public constants
   private static int count = 0;

   /**
    * The following define the enumerations.
    */

   public static final MeterFaultAndIssueReasons ACCURACY_FAILURE           = new MeterFaultAndIssueReasons("Accuracy Failure", "Accuracy Failure");
   public static final MeterFaultAndIssueReasons AREA_EVENT                 = new MeterFaultAndIssueReasons("Area Event", "Area Event");
   public static final MeterFaultAndIssueReasons COMMUNICATION_FAILURE      = new MeterFaultAndIssueReasons("Communication Failure", "Communication Failure");
   public static final MeterFaultAndIssueReasons CONTRACTOR_FAILURE         = new MeterFaultAndIssueReasons("Contactor Failure", "Contactor Failure");
   public static final MeterFaultAndIssueReasons MALFUNCTION                = new MeterFaultAndIssueReasons("Malfunction", "Malfunction");
   public static final MeterFaultAndIssueReasons METER_BYPASSED             = new MeterFaultAndIssueReasons("Meter Bypassed", "Meter Bypassed");
   public static final MeterFaultAndIssueReasons METER_FAMILY_FAILURE       = new MeterFaultAndIssueReasons("Meter Family Failure", "Meter Family Failure");
   public static final MeterFaultAndIssueReasons METER_VERIFICATION         = new MeterFaultAndIssueReasons("Meter Verification", "Meter Verification");
   public static final MeterFaultAndIssueReasons METROLOGY_THRESHOLD_BREACH = new MeterFaultAndIssueReasons("Metrology Threshold Breach", "Metrology Threshold Breach");
   public static final MeterFaultAndIssueReasons NO_DISPLAY                 = new MeterFaultAndIssueReasons("No Display", "No Display");
   public static final MeterFaultAndIssueReasons PHYSICAL_DAMAGE            = new MeterFaultAndIssueReasons("Physical Damage", "Physical Damage");
   public static final MeterFaultAndIssueReasons THEFT_TAMPERING            = new MeterFaultAndIssueReasons("Theft/Tampering", "Theft/Tampering");
   public static final MeterFaultAndIssueReasons TIMESWITCH_LOAD_FAILURE    = new MeterFaultAndIssueReasons("Timeswitch/Controlled Load Failure", "Timeswitch/Controlled Load Failure");
   public static final MeterFaultAndIssueReasons OTHER                      = new MeterFaultAndIssueReasons("Other", "Other");

   private static final MeterFaultAndIssueReasons[] METER_FAULT_AND_ISSUE_REASONS_ARRAY = {
      ACCURACY_FAILURE,
      AREA_EVENT,
      COMMUNICATION_FAILURE,
      CONTRACTOR_FAILURE,
      MALFUNCTION,
      METER_BYPASSED,
      METER_FAMILY_FAILURE,
      METER_VERIFICATION,
      METROLOGY_THRESHOLD_BREACH,
      NO_DISPLAY,
      PHYSICAL_DAMAGE,
      THEFT_TAMPERING,
      TIMESWITCH_LOAD_FAILURE,
      OTHER
   };

   public static final List<? extends Object> METER_FAULT_AND_ISSUE_REASONS = Collections.unmodifiableList(Arrays.asList(METER_FAULT_AND_ISSUE_REASONS_ARRAY));

   private MeterFaultAndIssueReasons(String code,String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
   }

   public String toString() {
      return code + "-" + description;
   }

}

