/*
 * MeterFaultAndIssueSupplyOffOptions.java
 *
 * The Copyright of this work is vested in the Australian Energy Market
 * Operator (AEMO) and the software is issued in confidence for the purpose
 * only for which it is supplied. It must not be reproduced in whole or in
 * part or used for tendering or manufacturing purposes except under an
 * agreement or with the consent in writing of AEMO and then only on the
 * condition that this notice is included in any such reproduction.
 * No information as to the contents or subject matter of this software or
 * any part thereof arising directly or indirectly there from shall be
 * given orally or in writing or communicated in any manner whatsoever to
 * any third party being an individual firm or company or any employee
 * thereof without the prior consent in writing of AEMO.
 *
 * Copyright Australian Energy Market Operator Limited. 2017
 *
 * Modification History
 *
 * Date Changed   Changed By        Description
 * ------------   ----------        -----------
 * 10-Jul-2017    Harpreet Kaur     Created
 */


package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class MeterFaultAndIssueSupplyOffOptions extends Enumeration implements Comparable<Object>, java.io.Serializable {
   // Public constants
   private static int count = 0;

   /**
    * The following define the enumerations.
    */

   public static final MeterFaultAndIssueSupplyOffOptions LOCAL_METER_DISCONNECTION           = new MeterFaultAndIssueSupplyOffOptions("Local Meter Disconnection", "Local Meter Disconnection");
   public static final MeterFaultAndIssueSupplyOffOptions PILLAR_BOX_PIT                      = new MeterFaultAndIssueSupplyOffOptions("Pillar-Box Pit Or Pole-Top", "Pillar-Box Pit Or Pole-Top");
   public static final MeterFaultAndIssueSupplyOffOptions REMOTE                              = new MeterFaultAndIssueSupplyOffOptions("Remote", "Remote");
   public static final MeterFaultAndIssueSupplyOffOptions REMOVE_FUSE                         = new MeterFaultAndIssueSupplyOffOptions("Remove Fuse", "Remove Fuse");

   private static final MeterFaultAndIssueSupplyOffOptions[] METER_FAULT_AND_ISSUE_SUPPLY_OFF_OPTIONS_ARRAY = {
      LOCAL_METER_DISCONNECTION,
      PILLAR_BOX_PIT,
      REMOTE,
      REMOVE_FUSE
   };


   public static final List<? extends Object> METER_FAULT_AND_ISSUE_SUPPLY_OFF_OPTIONS = Collections.unmodifiableList(Arrays.asList(METER_FAULT_AND_ISSUE_SUPPLY_OFF_OPTIONS_ARRAY));

   private MeterFaultAndIssueSupplyOffOptions(String code,String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
   }

   public String toString() {
      return code + "-" + description;
   }

}

