/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/MeterInstallCode.java-arc   1.2   08 Apr 2005 14:23:40   RayanS  $
 * $Revision:   1.2  $
 * $Date:   08 Apr 2005 14:23:40  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.2  $ $Date:   08 Apr 2005 14:23:40  $
 */

public class MeterInstallCode extends Enumeration 
                        implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;

  /**
   * The following define the enumerations.
   */
  public static final MeterInstallCode COMMS1 = new MeterInstallCode("COMMS1", "Interval Comms - Type 1");
  public static final MeterInstallCode COMMS2 = new MeterInstallCode("COMMS2", "Interval Comms  - Type 2");
  public static final MeterInstallCode COMMS3 = new MeterInstallCode("COMMS3", "Interval Comms - Type 3");
  public static final MeterInstallCode COMMS4 = new MeterInstallCode("COMMS4", "Interval Comms - Type 4");
  public static final MeterInstallCode COMMS4D = new MeterInstallCode("COMMS4D", "Interval Comms - Type 4 advanced whole current");
  public static final MeterInstallCode COMMS4C = new MeterInstallCode("COMMS4C", "Interval Comms - Type 4 advanced current transformer");
  public static final MeterInstallCode MRAM   = new MeterInstallCode("MRAM"  , "Manually Read Interval Meter - Type 4A");
  public static final MeterInstallCode MRIM   = new MeterInstallCode("MRIM"  , "Manually Read Interval Meter - Type 5");
  public static final MeterInstallCode VICAMI   = new MeterInstallCode("VICAMI"  , "VIC AMI");
  public static final MeterInstallCode BASIC  = new MeterInstallCode("BASIC" , "Basic Consumption Meter - Type 6");
  public static final MeterInstallCode UMCP   = new MeterInstallCode("UMCP"  , "Unmetered Supply - Type 7");
  public static final MeterInstallCode PROF   = new MeterInstallCode("PROF"  , "Profile Setup Only");
  public static final MeterInstallCode SAMPLE = new MeterInstallCode("SAMPLE", "Sample Meter");

  private static final MeterInstallCode[] METER_INSTALL_CODE_ARRAY =
    { BASIC,
      COMMS1,
      COMMS2,
      COMMS3,
      COMMS4,
      COMMS4D,
      COMMS4C,
      MRAM,
      MRIM,
      VICAMI,
      PROF,
      SAMPLE,
      UMCP
    };

  public static final List<? extends Object> METER_INSTALL_CODES =
    Collections.unmodifiableList(Arrays.asList(METER_INSTALL_CODE_ARRAY));

  private MeterInstallCode(String code, 
                 String description) {
    this.code = code;
    this.description = description;
    this.number = ++count;
  }

  public String toString() {
    return code + "-" + description;
  }

}

