/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/MovementType.java-arc   1.4   08 Apr 2005 14:23:40   RayanS  $
 * $Revision:   1.4  $
 * $Date:   08 Apr 2005 14:23:40  $
 *
 * Copyright 2005 Capgemini Australia Pty. Ltd.
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 *
 * Modification History
 *
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 19-Oct-2009    Eddie Graham      Defect 5974. Add new option 'Reconciliation - Site Vacant'.
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 * 17-Jun-2013    Eddie Graham      Defect 2167. Remove option 'Reconciliation - Site Vacant'.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.4  $ $Date:   08 Apr 2005 14:23:40  $
 */

public class MovementType extends Enumeration
                          implements Comparable<Object>, java.io.Serializable {
  // Public constants
  private static int count = 0;

  /**
   * The following define the enumerations.
   */
  public static final MovementType SITE_VACANT     = new MovementType("Site Vacant", "Site Vacant");
  public static final MovementType UPDATE          = new MovementType("Update" , "Update");
  public static final MovementType RECONCILIATION  = new MovementType("Reconciliation", "Reconciliation");

  private static final MovementType[] MOVEMENT_TYPE_ARRAY =
  { SITE_VACANT,
    UPDATE,
    RECONCILIATION
  };

  public static final List<? extends Object> MOVEMENT_TYPES =
    Collections.unmodifiableList(Arrays.asList(MOVEMENT_TYPE_ARRAY));

  private MovementType(String code,
                       String description) {
    this.code = code;
    this.description = description;
    this.number = ++count;
  }

  public String toString() {
    return code + "-" + description;
  }

}

