/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/NMIStatusCode.java-arc   1.1   08 Apr 2005 14:23:40   RayanS  $
 * $Revision:   1.1  $
 * $Date:   08 Apr 2005 14:23:40  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.1  $ $Date:   08 Apr 2005 14:23:40  $
 */

public class NMIStatusCode extends Enumeration 
                                      implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
  
    /**
		  * The following define the enumerations.
		  */
    public static final NMIStatusCode X = new NMIStatusCode("X", "Extinct NMI");
    public static final NMIStatusCode A = new NMIStatusCode("A", "Active NMI");
    public static final NMIStatusCode D = new NMIStatusCode("D", "Not Energised");
    public static final NMIStatusCode G = new NMIStatusCode("G", "Greenfield Site NMI");
    public static final NMIStatusCode N = new NMIStatusCode("N", "Off Market Child NMI");
    
    private static final NMIStatusCode[] NMI_STATUS_TYPE =
      { X,
        A,
        D,
        G,
        N
      };

    public static final List<? extends Object> NMI_STATUS_CODES =
      Collections.unmodifiableList(Arrays.asList(NMI_STATUS_TYPE));

    private NMIStatusCode(String code, 
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }

}

