/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/NameType.java-arc   1.4   08 Apr 2005 14:23:40   RayanS  $
 * $Revision:   1.4  $
 * $Date:   08 Apr 2005 14:23:40  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 *
 * Modification History
 *
 * Date Changed   Changed By        Description
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the NameType Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.4  $ $Date:   08 Apr 2005 14:23:40  $
 */

public class NameType extends Enumeration 
                              implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
  
	/**
	 * The following define the enumerations.
	 */
	 public static final NameType LGL = new NameType("LGL" , "LGL");
   public static final NameType MDN = new NameType("MDN" , "MDN");
	 public static final NameType BTH = new NameType("BTH" , "BTH");
	 public static final NameType TRB = new NameType("TRB" , "TRB");
	 public static final NameType PRF = new NameType("PRF" , "PRF");
	 public static final NameType AKA = new NameType("AKA" , "AKA");
	 public static final NameType XFR = new NameType("XFR" , "XFR");
	 public static final NameType STG = new NameType("STG" , "STG");


    private static final NameType[] NAME_TYPE_ARRAY =
      { LGL,
        MDN, 
        BTH, 
        TRB,
        PRF,
        AKA,
        XFR,
        STG
      };

    public static final List<? extends Object> NAME_TYPES =
      Collections.unmodifiableList(Arrays.asList(NAME_TYPE_ARRAY));

    private NameType(String code, 
                     String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }

}

