/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/OffPeakRequirement.java-arc   1.3   08 Apr 2005 14:23:40   RayanS  $
 * $Revision:   1.3  $
 * $Date:   08 Apr 2005 14:23:40  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.3  $ $Date:   08 Apr 2005 14:23:40  $
 */

public class OffPeakRequirement extends Enumeration 
                                implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
  
    /**
		  * The following define the enumerations.
		  */
    public static final OffPeakRequirement SPACE_HEATING = new OffPeakRequirement("Space heating", "Space heating");
    public static final OffPeakRequirement CLIMATE_SAVER = new OffPeakRequirement("Climate Saver", "Climate Saver");
    public static final OffPeakRequirement HOT_WATER     = new OffPeakRequirement("Hot Water", "Hot Water");
    
    private static final OffPeakRequirement[] OFF_PEAK_REQ_ARRAY =
      { SPACE_HEATING,
        CLIMATE_SAVER,
        HOT_WATER
      };

    public static final List<? extends Object> OFF_PEAK_REQUIREMENTS =
      Collections.unmodifiableList(Arrays.asList(OFF_PEAK_REQ_ARRAY));

    private OffPeakRequirement(String code, 
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }

}

