/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/PostalDeliveryType.java-arc   1.2   15 Apr 2005 14:11:44   hendyl  $
 * $Revision:   1.2  $
 * $Date:   15 Apr 2005 14:11:44  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * 
 * Modification History
 *
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 04-Jul-2011    Eddie Graham      Defect 7366. Derive enumerations from aseXML Enumerations schema file.
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import com.sun.xml.xsom.XSFacet;
import com.sun.xml.xsom.XSRestrictionSimpleType;
import com.sun.xml.xsom.XSSchema;

import com.sun.xml.xsom.XSSimpleType;

import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

/**
 * Defines the Enumeration
 *
 * @author $Author:   hendyl  $
 * @version $Revision:   1.2  $ $Date:   15 Apr 2005 14:11:44  $
 */

public class PostalDeliveryType extends Enumeration 
                        implements Comparable<Object>, java.io.Serializable {
	// Public constants
   private static int count = 0;

   public static List<? extends Object> POSTAL_DELIVERY_TYPE_CODES;  
 
   public static void setPostalDeliveryType(XSSchema xsSchema) {
      PostalDeliveryType[] postalDeliveryType = null;    
   
      XSSimpleType st = xsSchema.getSimpleType("AustralianPostalDeliveryType");

      if(st != null){
         XSRestrictionSimpleType restriction = st.asRestriction();
         
         if(restriction != null){
            Vector<PostalDeliveryType> enumeration = new Vector<PostalDeliveryType>();         
            Iterator<? extends XSFacet> i = restriction.getDeclaredFacets().iterator();
            while(i.hasNext()){
               XSFacet facet = (XSFacet)i.next();
               if(facet.getName().equals(XSFacet.FACET_ENUMERATION)){             
                  enumeration.add(new PostalDeliveryType(facet.getValue().value,facet.getValue().value));
               }
            }
         
            if(enumeration.size() > 0){
               postalDeliveryType = enumeration.toArray(new PostalDeliveryType[]{});
               Arrays.sort(postalDeliveryType);                 
               POSTAL_DELIVERY_TYPE_CODES = Collections.unmodifiableList(Arrays.asList(postalDeliveryType));            
            }
         }
      }
   } 

   private PostalDeliveryType(String code, 
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
   }

   public String toString() {
      return code + "-" + description;
   }
}

