/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/Priority.java-arc   1.3   11 Apr 2005 11:10:46   RayanS  $
 * $Revision:   1.3  $
 * $Date:   11 Apr 2005 11:10:46  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the priority Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.3  $ $Date:   11 Apr 2005 11:10:46  $
 */
public class Priority extends Enumeration implements Comparable<Object>, java.io.Serializable {

  // count will be seen as zero despite its value unless it's before the
  // public constant declarations
  private static int count = 0;

  public static final Priority LOW = new Priority("Low", "Low");
  public static final Priority MEDIUM = new Priority("Medium", "Medium");
  public static final Priority HIGH = new Priority("High", "High");

  private static final Priority[] PRIORITY_ARRAY = {
      LOW, MEDIUM, HIGH};

  public static final List<? extends Object> PRIORITIES = Collections.unmodifiableList(Arrays.asList(PRIORITY_ARRAY));

  /**
   * Return the Priority object given by code (key)
   * 
   * @param code
   *          The key to find in this enumeration
   * @return The object associated with the key. Null otherwise
   */
  public static Priority getPriority(String code) {
    for (int i = 0; i < PRIORITIES.size(); i++) {
      if ((((Enumeration) PRIORITIES.get(i)).getCode()).equals(code))
          return (Priority) PRIORITIES.get(i);
    }
    return null;
  }

  private Priority(String code, String description) {
    this.code = code;
    this.description = description;
    this.number = ++count;
  }
}

