/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/RebateCode.java-arc   1.3   08 Apr 2005 14:23:42   RayanS  $
 * $Revision:   1.3  $
 * $Date:   08 Apr 2005 14:23:42  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.3  $ $Date:   08 Apr 2005 14:23:42  $
 */

public class RebateCode extends Enumeration 
                          implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
  
	/**
	 * The following define the enumerations.
	 */
	 public static final RebateCode PENSION_CARD    = new RebateCode("Pension Card", "Pension Card");
	 public static final RebateCode HEALTH_CARE     = new RebateCode("Health Care Card" , "Health Care Card");
	 public static final RebateCode HEALTH_BENEFIT  = new RebateCode("Health Benefit Card" , "Health Benefit Card");
	 public static final RebateCode VETERAN_AFFAIRS = new RebateCode("Veteran Affairs Card" , "Veteran Affairs Card");


    private static final RebateCode[] REBATE_CODE_ARRAY =
      { PENSION_CARD,
        HEALTH_CARE,
        HEALTH_BENEFIT,
        VETERAN_AFFAIRS
      };

    public static final List<? extends Object> REBATE_CODES =
      Collections.unmodifiableList(Arrays.asList(REBATE_CODE_ARRAY));

    private RebateCode(String code, 
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }

}

