/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/SORRole.java-arc   1.1   08 Apr 2005 14:23:42   RayanS  $
 * $Revision:   1.1  $
 * $Date:   08 Apr 2005 14:23:42  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.1  $ $Date:   08 Apr 2005 14:23:42  $
 */

public class SORRole extends Enumeration 
                        implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
  
    /**
		  * The following define the enumerations.
		  */
    public static final SORRole RP  = new SORRole("RP" , "RP");
    public static final SORRole MDP = new SORRole("MDP", "MDP");
    public static final SORRole MPB = new SORRole("MPB", "MPB");
    public static final SORRole MPC = new SORRole("MPC", "MPC");

    private static final SORRole[] SOR_ROLE_ARRAY =
      { RP,
        MDP,
        MPB,
        MPC
      };

    public static final List<? extends Object> SOR_ROLES =
      Collections.unmodifiableList(Arrays.asList(SOR_ROLE_ARRAY));

    private SORRole(String code, 
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }


    public String toString() {
      return code + "-" + description;
    }

}

