/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/SafetyCertMethodSentType.java-arc   1.3   08 Apr 2005 14:23:42   RayanS  $
 * $Revision:   1.3  $
 * $Date:   08 Apr 2005 14:23:42  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.3  $ $Date:   08 Apr 2005 14:23:42  $
 */

public class SafetyCertMethodSentType extends Enumeration 
                                      implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
  
    /**
		  * The following define the enumerations.
		  */
    public static final SafetyCertMethodSentType FAXED  = new SafetyCertMethodSentType("Faxed", "Faxed");
    public static final SafetyCertMethodSentType EMAIL  = new SafetyCertMethodSentType("Email", "Email");
    public static final SafetyCertMethodSentType ONLINE = new SafetyCertMethodSentType("Online", "Online");
    public static final SafetyCertMethodSentType ONSITE = new SafetyCertMethodSentType("OnSite", "OnSite");
    
    private static final SafetyCertMethodSentType[] SAFETY_CERT_METHOD_SENT_ARRAY =
      { FAXED,
        EMAIL,
        ONLINE,
        ONSITE
      };

    public static final List<? extends Object> SAFETY_CERT_METHOD_SENT_TYPES =
      Collections.unmodifiableList(Arrays.asList(SAFETY_CERT_METHOD_SENT_ARRAY));

    private SafetyCertMethodSentType(String code, 
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }

}

