/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/SensitiveLoad.java-arc   1.1   08 Apr 2005 14:23:42   RayanS  $
 * $Revision:   1.1  $
 * $Date:   08 Apr 2005 14:23:42  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed  Changed By     Comments
 * ------------  ----------     --------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.1  $ $Date:   08 Apr 2005 14:23:42  $
 */

public class SensitiveLoad extends Enumeration 
                           implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
  
	/**
	 * The following define the enumerations.
	 */
	 public static final SensitiveLoad LIFE_SUPPORT     = new SensitiveLoad("Life Support", "Life Support");
	 public static final SensitiveLoad SENSITIVE_LOAD   = new SensitiveLoad("Sensitive Load" , "Sensitive Load");
   public static final SensitiveLoad NONE             = new SensitiveLoad("None" , "None");
  

    private static final SensitiveLoad[] SENSITIVE_LOAD_ARRAY =
      { 
        LIFE_SUPPORT,
        SENSITIVE_LOAD,
        NONE
      };

    public static final List<? extends Object> SENSITIVE_LOADS =
      Collections.unmodifiableList(Arrays.asList(SENSITIVE_LOAD_ARRAY));

    private SensitiveLoad(String code, 
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }

}

