/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/ServiceOrderSubType.java-arc   1.6   08 Apr 2005 14:23:42   RayanS  $
 * $Revision:   1.6  $
 * $Date:   08 Apr 2005 14:23:42  $
 *
 * Copyright 2005 Capgemini Australia Pty. Ltd.
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7.
 * 27-June-2017   NG             7135 - PoC SMP Changes
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.6  $ $Date:   08 Apr 2005 14:23:42  $
 */

public class ServiceOrderSubType extends Enumeration
                                 implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;

    /**
		  * The following define the enumerations.
		  */
    // Supply Service Works
    public static final ServiceOrderSubType ALLOCATE_NMI_SUB_TYPE  = new ServiceOrderSubType("Allocate NMI","Allocate NMI", ServiceOrderType.SUPP_SRV_WRK);
    public static final ServiceOrderSubType SUPPLY_ABOLISHMENT  = new ServiceOrderSubType("Supply Abolishment","Supply Abolishment", ServiceOrderType.SUPP_SRV_WRK);
    public static final ServiceOrderSubType SUPPLY_ALTERATION  = new ServiceOrderSubType("Supply Alteration","Supply Alteration", ServiceOrderType.SUPP_SRV_WRK);
    public static final ServiceOrderSubType TARIFF_CHANGE  = new ServiceOrderSubType("Tariff Change","Tariff Change", ServiceOrderType.SUPP_SRV_WRK);
    public static final ServiceOrderSubType ESTABLISH_TEMPORARY_SUPPLY  = new ServiceOrderSubType("Establish Temporary Supply","Establish Temporary Supply", ServiceOrderType.SUPP_SRV_WRK);
    public static final ServiceOrderSubType ESTABLISH_TEMPORARY_IN_PERMANENT  = new ServiceOrderSubType("Establish Temporary In Permanent","Establish Temporary In Permanent", ServiceOrderType.SUPP_SRV_WRK);
    public static final ServiceOrderSubType ESTABLISH_PERMANENT_SUPPLY  = new ServiceOrderSubType("Establish Permanent Supply","Establish Permanent Supply", ServiceOrderType.SUPP_SRV_WRK);
    public static final ServiceOrderSubType TEMPORARY_ISOLATION  = new ServiceOrderSubType("Temporary Isolation","Temporary Isolation", ServiceOrderType.SUPP_SRV_WRK);
    public static final ServiceOrderSubType TEMPORARY_ISOLATION_GROUP  = new ServiceOrderSubType("Temporary Isolation-Group Supply","Temporary Isolation-Group Supply", ServiceOrderType.SUPP_SRV_WRK);

    //Metering Service Works
    public static final ServiceOrderSubType INSTALL_CONTROLLED_LOAD= new ServiceOrderSubType("Install Controlled Load","Install Controlled Load", ServiceOrderType.METER_SRV_WRK);
    public static final ServiceOrderSubType MOVE_METER             = new ServiceOrderSubType("Move Meter","Move Meter", ServiceOrderType.METER_SRV_WRK);
    public static final ServiceOrderSubType INSTALL_METER          = new ServiceOrderSubType("Install Meter","Install Meter", ServiceOrderType.METER_SRV_WRK);
    public static final ServiceOrderSubType REMOVE_METER           = new ServiceOrderSubType("Remove Meter","Remove Meter", ServiceOrderType.METER_SRV_WRK);
    public static final ServiceOrderSubType EXCHANGE_METER         = new ServiceOrderSubType("Exchange Meter","Exchange Meter", ServiceOrderType.METER_SRV_WRK);
    public static final ServiceOrderSubType METER_RECONFIGURATION = new ServiceOrderSubType("Meter Reconfiguration","Meter Reconfiguration", ServiceOrderType.METER_SRV_WRK);
    public static final ServiceOrderSubType METER_INVESTIGATION_INSPECT  = new ServiceOrderSubType("Meter Investigation-Inspect","Meter Investigation-Inspect", ServiceOrderType.METER_SRV_WRK);
    public static final ServiceOrderSubType METER_INVESTIGATION_TEST  = new ServiceOrderSubType("Meter Investigation-Test","Meter Investigation-Test", ServiceOrderType.METER_SRV_WRK);
    public static final ServiceOrderSubType CHANGE_TIMESWITCH_SETTINGS     = new ServiceOrderSubType("Change Timeswitch Settings","Change Timeswitch Settings", ServiceOrderType.METER_SRV_WRK);
    public static final ServiceOrderSubType RESEAL_DEVICE     = new ServiceOrderSubType("Reseal Device","Reseal Device", ServiceOrderType.METER_SRV_WRK);

    // Re-energisation
    public static final ServiceOrderSubType AFTER_DISCONNECT       = new ServiceOrderSubType("After Disconnection For Non-Payment","After Disconnection For Non-Payment", ServiceOrderType.RE_ENERGISATION);
    public static final ServiceOrderSubType RE_EN_REMOTE        = new ServiceOrderSubType("Remote","Remote", ServiceOrderType.RE_ENERGISATION);
    public static final ServiceOrderSubType RETROSPECTIVE_MOVE_IN  = new ServiceOrderSubType("Retrospective Move-in","Retrospective Move-in", ServiceOrderType.RE_ENERGISATION);
    public static final ServiceOrderSubType NEW_READING_REQUIRED   = new ServiceOrderSubType("New Reading Required","New Reading Required", ServiceOrderType.RE_ENERGISATION);
    public static final ServiceOrderSubType PHYSICAL_VISIT   = new ServiceOrderSubType("Physical Visit","Physical Visit", ServiceOrderType.RE_ENERGISATION);
    public static final ServiceOrderSubType MOVE_IN   = new ServiceOrderSubType("Move-in","Move-in", ServiceOrderType.RE_ENERGISATION);
    public static final ServiceOrderSubType RE_EN_RECIPIENT_DISCRETION   = new ServiceOrderSubType("Recipient Discretion","Recipient Discretion", ServiceOrderType.RE_ENERGISATION);
    // De-energisation
    public static final ServiceOrderSubType PILLAR_OR_POLE         = new ServiceOrderSubType("Disconnect at Pillar-Box Pit Or Pole-Top","Disconnect at Pillar-Box Pit Or Pole-Top", ServiceOrderType.DE_ENERGISATION);
    public static final ServiceOrderSubType REMOVE_FUSE            = new ServiceOrderSubType("Remove Fuse","Remove Fuse", ServiceOrderType.DE_ENERGISATION);
    public static final ServiceOrderSubType DE_EN_REMOTE        = new ServiceOrderSubType("Remote","Remote", ServiceOrderType.DE_ENERGISATION);
    public static final ServiceOrderSubType LOCAL_METER_DISCONNECTION  = new ServiceOrderSubType("Local Meter Disconnection","Local Meter Disconnection", ServiceOrderType.DE_ENERGISATION);
    public static final ServiceOrderSubType DE_EN_RECIPIENT_DISCRETION   = new ServiceOrderSubType("Recipient Discretion","Recipient Discretion", ServiceOrderType.DE_ENERGISATION);
    // Special Read
    public static final ServiceOrderSubType CHECK_READ             = new ServiceOrderSubType("Check Read","Check Read", ServiceOrderType.SPECIAL_READ);
    public static final ServiceOrderSubType FINAL_READ             = new ServiceOrderSubType("Final Read","Final Read", ServiceOrderType.SPECIAL_READ);


    private static final ServiceOrderSubType[] SERVICE_ORDER_SUB_TYPE_ARRAY =
      { ALLOCATE_NMI_SUB_TYPE,
        SUPPLY_ABOLISHMENT,
		SUPPLY_ALTERATION,
		TARIFF_CHANGE,
		ESTABLISH_TEMPORARY_SUPPLY,
		ESTABLISH_TEMPORARY_IN_PERMANENT,
		ESTABLISH_PERMANENT_SUPPLY,
		TEMPORARY_ISOLATION,
		TEMPORARY_ISOLATION_GROUP,
		
		INSTALL_CONTROLLED_LOAD,
		MOVE_METER,
		INSTALL_METER,
        REMOVE_METER,
        EXCHANGE_METER,
        METER_RECONFIGURATION,
        METER_INVESTIGATION_INSPECT,
        METER_INVESTIGATION_TEST,
        CHANGE_TIMESWITCH_SETTINGS,
        RESEAL_DEVICE,
		
		AFTER_DISCONNECT,
		RE_EN_REMOTE,
		RETROSPECTIVE_MOVE_IN,
		NEW_READING_REQUIRED,
		PHYSICAL_VISIT,
		MOVE_IN,
		RE_EN_RECIPIENT_DISCRETION,
		
        PILLAR_OR_POLE,
		REMOVE_FUSE,
		DE_EN_REMOTE,
		LOCAL_METER_DISCONNECTION,
		DE_EN_RECIPIENT_DISCRETION,
		
		CHECK_READ,
		FINAL_READ
      };

    public static final List<? extends Object> SERVICE_ORDER_SUB_TYPES =
      Collections.unmodifiableList(Arrays.asList(SERVICE_ORDER_SUB_TYPE_ARRAY));

    final ServiceOrderType serviceOrderType;

    private ServiceOrderSubType(String code,
                                String description,
                                ServiceOrderType serviceOrderType) {
      this.code = code;
      this.description = description;
      this.serviceOrderType = serviceOrderType;
      this.number = ++count;
    }

    public ServiceOrderType getServiceOrderType() {
      return serviceOrderType;
    }

    public String toString() {
      return code + "-" + description;
    }

    // gets a sub list depending on the service order type provided
    static public List<Object> getSubTypeList(String parenttype) {
      ArrayList<Object> list = new ArrayList<Object>();
      for (int i = 0; i < SERVICE_ORDER_SUB_TYPES.size(); i++) {
        ServiceOrderType subType = (((ServiceOrderSubType) SERVICE_ORDER_SUB_TYPES.get(i))).getServiceOrderType();
        if ((subType.getCode()).equals(parenttype)){
          list.add(SERVICE_ORDER_SUB_TYPES.get(i));
        }
      }
      return list;
    }
    static public boolean isValidServiceOrderAndSubType(String type, String subType) {
        for(ServiceOrderSubType serviceOrderSubType : Arrays.asList(SERVICE_ORDER_SUB_TYPE_ARRAY)) {
            if(serviceOrderSubType.getCode().equals(subType)) {
                if(serviceOrderSubType.getServiceOrderType().getCode().equalsIgnoreCase(type)) {
                    return true;
                }
            }
        }
        return false;
    }
}

