/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/Severity.java-arc   1.3   11 Apr 2005 11:10:46   RayanS  $
 * $Revision:   1.3  $
 * $Date:   11 Apr 2005 11:10:46  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Severity
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.3  $ $Date:   11 Apr 2005 11:10:46  $
 */
public class Severity extends Enumeration implements Comparable<Object>,
    java.io.Serializable {

  // count will be seen as zero despite its value unless it's before the
  // public constant declarations
  private static int count = 0;

  public static final Severity INFO = new Severity("Information", "Information");
  public static final Severity WARN = new Severity("Warning", "Warning");
  public static final Severity ERROR = new Severity("Error", "Error");
  public static final Severity FATAL = new Severity("Fatal", "Fatal");

  private static final Severity[] SEVERITY_ARRAY = {
      INFO, WARN, ERROR, FATAL};

  public static final List<? extends Object> SEVERITY = Collections.unmodifiableList(Arrays
      .asList(SEVERITY_ARRAY));

  /**
   * Return the Severity object given by code (key)
   * 
   * @param code
   *          The key to find in this enumeration
   * @return The object associated with the key. Null otherwise
   */
  public static Severity getSeverity(String code) {
    for (int i = 0; i < SEVERITY.size(); i++) {
      if ((((Enumeration) SEVERITY.get(i)).getCode()).equals(code))
          return (Severity) SEVERITY.get(i);
    }
    return null;
  }

  private Severity(String code, String description) {
    this.code = code;
    this.description = description;
    this.number = ++count;
  }
}

