/*
* SiteAccessRequestReasons.java
*
* The Copyright of this work is vested in the Australian Energy Market
* Operator (AEMO) and the software is issued in confidence for the purpose
* only for which it is supplied. It must not be reproduced in whole or in
* part or used for tendering or manufacturing purposes except under an
* agreement or with the consent in writing of AEMO and then only on the
* condition that this notice is included in any such reproduction.
* No information as to the contents or subject matter of this software or
* any part thereof arising directly or indirectly there from shall be
* given orally or in writing or communicated in any manner whatsoever to
* any third party being an individual firm or company or any employee
* thereof without the prior consent in writing of AEMO.
*
* Copyright Australian Energy Market Operator Limited. 2017
*
* Modification History
*
* Date Changed   Changed By        Description
* ------------   ----------        -----------
* 29-Jun-2017    Harpreet Kaur     Created
*/

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class SiteAccessRequestReasons extends Enumeration implements Comparable<Object>, java.io.Serializable {
   // Public constants
   private static int count = 0;

   /**
    * The following define the enumerations.
    */
   public static final SiteAccessRequestReasons NEW_RETAILER              = new SiteAccessRequestReasons("New Retailer for site", "New Retailer for site");
   public static final SiteAccessRequestReasons NO_ACCESS_DETAILS_ON_FILE = new SiteAccessRequestReasons("No Access details on file for NMI", "No Access details on file for NMI");
   public static final SiteAccessRequestReasons NO_HAZARD_DETAILS_ON_FILE = new SiteAccessRequestReasons("No Hazard Details on file for NMI", "No Hazard Details on file for NMI");
   public static final SiteAccessRequestReasons OLD_RECORDS_TO_BE_UPDATED = new SiteAccessRequestReasons("Records old and need to be updated", "Records old and need to be updated");
   public static final SiteAccessRequestReasons SITE_VISIT_REQUIRED       = new SiteAccessRequestReasons("Site Visit Required", "Site Visit Required");
   public static final SiteAccessRequestReasons OTHER                     = new SiteAccessRequestReasons("Other", "Other");


   private static final SiteAccessRequestReasons[] SITE_ACCESS_REQUEST_REASONS_ARRAY = {
      NEW_RETAILER,
      NO_ACCESS_DETAILS_ON_FILE,
      NO_HAZARD_DETAILS_ON_FILE,
      OLD_RECORDS_TO_BE_UPDATED,
      SITE_VISIT_REQUIRED,
      OTHER
   };

   public static final List<? extends Object> SITE_ACCESS_REQUEST_REASONS = Collections.unmodifiableList(Arrays.asList(SITE_ACCESS_REQUEST_REASONS_ARRAY));

   private SiteAccessRequestReasons(String code,String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
   }

   public String toString() {
      return code + "-" + description;
   }

}

