/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/SortBy.java-arc   1.2   28 Feb 2005 10:54:26   RayanS  $ 
 * $Revision:   1.2  $ 
 * $Date:   28 Feb 2005 10:54:26  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved. 
 * NEMMCO CONFIDENTIAL.
 * Date Changed  Changed By     Comments
 * ------------  ----------     --------
 * 14-Aug-2012   Bob Jones      7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the sort by enums used on the directory page
 * 
 * @author $Author:   RayanS  $
 * @version $Revision:   1.2  $ $Date:   28 Feb 2005 10:54:26  $
 */
public class SortBy extends Enumeration {

  // count will be seen as zero despite its value unless it's before the
  // public constant declarations
  private static int count = 0;
  
  public static final SortBy EXTENSION = new SortBy("Extension", "Extension");
  public static final SortBy FILENAME = new SortBy("Filename", "Filename");
  public static final SortBy LASTMODIFIED = new SortBy("Last Modified",
      "Last Modified");
  public static final SortBy PRIORITY = new SortBy("Priority", "Priority");

  private static final SortBy[] SORT_BY_ARRAY = {
      FILENAME, EXTENSION, PRIORITY, LASTMODIFIED};

  public static final List<? extends Object> SORT_BYS = Collections.unmodifiableList(Arrays
      .asList(SORT_BY_ARRAY));

  /**
   * Return the SortBy object given by the code (key)
   * 
   * @param code
   *          The code to find in this enumeration
   * @return The object associated with the key; null otherwise
   */
  public static SortBy getSortBy(String code) {
    for (int i = 0; i < SORT_BYS.size(); i++) {
      if ((((Enumeration) SORT_BYS.get(i)).getCode()).equals(code)) {
        return (SortBy) SORT_BYS.get(i);
      }   
    }
    return null;
  }

  private SortBy(String code, String description) {
    this.code = code;
    this.description = description;
    this.number = ++count;
  }
}

