/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/SortOrder.java-arc   1.3   11 Apr 2005 11:10:46   RayanS  $ 
 * $Revision:   1.3  $ 
 * $Date:   11 Apr 2005 11:10:46  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved. 
 * NEMMCO CONFIDENTIAL.
 * NEMMCO CONFIDENTIAL.
 * Date Changed  Changed By     Comments
 * ------------  ----------     --------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the sort by enums used on the directory page
 * 
 * @author $Author:   RayanS  $
 * @version $Revision:   1.3  $ $Date:   11 Apr 2005 11:10:46  $
 */
public class SortOrder extends Enumeration {
  
  // count will be seen as zero despite its value unless it's before the
  // public constant declarations
  private static int count = 0;
  
  public static final SortOrder ASC = new SortOrder("Ascending", "Ascending");
  public static final SortOrder DESC = new SortOrder("Descending", "Descending");

  private static final SortOrder[] SORT_ORDER_ARRAY = {
      ASC, DESC};

  public static final List<? extends Object> SORT_ORDERS = Collections.unmodifiableList(Arrays
      .asList(SORT_ORDER_ARRAY));

  /**
   * Return the SortOrder object given by code (key)
   * 
   * @param code
   *          The key to find in this enumeration
   * @return The object associated with the key. Null otherwise
   */
  public static SortOrder getSortOrder(String code) {
    for (int i = 0; i < SORT_ORDERS.size(); i++) {
      if ((((Enumeration) SORT_ORDERS.get(i)).getCode()).equals(code))
          return (SortOrder) SORT_ORDERS.get(i);
    }
    return null;
  }

  private SortOrder(String code, String description) {
    this.code = code;
    this.description = description;
    this.number = ++count;
  }
}

