/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/Status.java-arc   1.4   11 Apr 2005 11:10:46   RayanS  $
 * $Revision:   1.4  $
 * $Date:   11 Apr 2005 11:10:46  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the priority Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.4  $ $Date:   11 Apr 2005 11:10:46  $
 */
public class Status extends Enumeration implements Comparable<Object>, java.io.Serializable {
  // Public constants
  private static int count = 0;

  /**
   * The following define the Transaction Type enumerations.
   */
  public static final Status ACCEPT = new Status("Accept", "Accept");
  public static final Status PARTIAL = new Status("Partial", "Partial");
  public static final Status REJECT = new Status("Reject", "Reject");

  private static final Status[] STATUS_TYPE_ARRAY = { ACCEPT, PARTIAL, REJECT };

  public static final List<? extends Object> STATUSES = Collections.unmodifiableList(Arrays.asList(STATUS_TYPE_ARRAY));

  private Status(String code, String description) {
    this.code = code;
    this.description = description;
    this.number = ++count;
  }
  
  /**
   * Return the Status object given by code (key)
   * 
   * @param code
   *          The key to find in this enumeration
   * @return The object associated with the key. Null otherwise
   */
  public static Status getStatus(String code) {
    for (int i = 0; i < STATUSES.size(); i++) {
      if ((((Enumeration) STATUSES.get(i)).getCode()).equals(code))
          return (Status) STATUSES.get(i);
    }
    return null;
  }
}

