/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/enums/SupplyPhase.java-arc   1.4   08 Apr 2005 14:23:44   RayanS  $
 * $Revision:   1.4  $
 * $Date:   08 Apr 2005 14:23:44  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 14-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.enums;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Defines the Enumeration
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.4  $ $Date:   08 Apr 2005 14:23:44  $
 */

public class SupplyPhase extends Enumeration 
                         implements Comparable<Object>, java.io.Serializable {
	// Public constants
  private static int count = 0;
  
    /**
		  * The following define the enumerations.
		  */
    public static final SupplyPhase ONE_PHASE         = new SupplyPhase("1-phase", "1-phase");
    public static final SupplyPhase TWO_PHASE         = new SupplyPhase("2-phase", "2-phase");
    public static final SupplyPhase THREE_PHASE       = new SupplyPhase("3-phase", "3-phase");
    public static final SupplyPhase OTHER_MULTIPHASE  = new SupplyPhase("Other Multi-phase", "Other Multi-phase");
    public static final SupplyPhase UNKNOWN  = new SupplyPhase("Unknown", "Unknown");
    
    private static final SupplyPhase[] SUPPLY_PHASE_ARRAY =
      { ONE_PHASE,
        TWO_PHASE,
        THREE_PHASE,
        OTHER_MULTIPHASE,
        UNKNOWN
      };

    public static final List<? extends Object> SUPPLY_PHASE_TYPES =
      Collections.unmodifiableList(Arrays.asList(SUPPLY_PHASE_ARRAY));

    private SupplyPhase(String code, 
                   String description) {
      this.code = code;
      this.description = description;
      this.number = ++count;
    }

    public String toString() {
      return code + "-" + description;
    }

}

