/*
 * @(#)Enumeration.java 0.1 Feb 23, 2005
 *
 * Copyright 2005 Capgemini Pty. Ltd. All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * 
 * Modification History
 * ====================
 * Date Changed  Changed By         Comments
 * ------------  ----------         ----------------
 * Feb 23, 2005  Rayan Stephan      Initial Creation
 */

package com.capgemini.nemmco.b2bb.lookup;

import com.capgemini.nemmco.b2bb.enums.Enumeration;
import java.sql.SQLException;

/**
 * Defines the super class of a lookup. Each enumeration requires 
 * at least a code. A lookup is similar to an Enumeration except
 * it is retrieved fom an external source such as the database or
 * file system 
 *
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.5  $ $Date:   08 Apr 2005 14:26:56  $
 */

public class Lookup extends Enumeration {

	  /**
	   * 
	   * @param result integer representing the result of the database lookup
	   * @param description description of an error if one occured
	   * @return true if everything was fine. Throws an SQLException otherwise.
	   */
	  protected static boolean checkResult(int result , String description) throws SQLException {
	    int PASS = 0;
	    if (result == PASS) return true;
	    else throw new SQLException(description);
	  }

}

