/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/utils/XPath.java-arc   1.5   21 Mar 2005 17:32:50   RayanS  $
 * $Revision:   1.5  $
 * $Date:   21 Mar 2005 17:32:50  $
 *
 * Copyright 2005 Capgemini Australia Pty. Ltd.
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 *
 * Modification History
 *
 * Date Changed   Changed By        Comments
 * ------------   ----------        ----------- 
 * 10-Aug-2012    Bob Jones         7984 Java upgrade from 6 to 7. 
 */

package com.capgemini.nemmco.b2bb.utils;

import java.util.ArrayList;

import org.w3c.dom.Node;

/**
 * Defines an xpath and provides useful methods to manipulate the
 * expression
 *
 * @author $Author:   RayanS  $
 * @version $Revision:   1.5  $ $Date:   21 Mar 2005 17:32:50  $
 */
public class XPath {
  String[] parts = null;

  String xpath = null;

  public XPath(String xpath) {
    this.xpath = xpath;

    ArrayList<Object> xPaths = new ArrayList<Object>();
    String current = null;
    int slashIndex = 0;
    int predicateIndex = -1;
    int predicateIndexEnd = -1;

    current = xpath;

    while (current != null) {
      slashIndex = current.indexOf("/");
      predicateIndex = current.indexOf("[");
      predicateIndexEnd = current.indexOf("]");

      if (slashIndex > -1) {
        if (slashIndex < predicateIndex || predicateIndex <= -1) {
          if (slashIndex > 0) {
            xPaths.add(current.substring(0, slashIndex));
          }
          current = current.substring(slashIndex + 1);
        } 
        else if (slashIndex > predicateIndexEnd) {
          xPaths.add(current.substring(0, slashIndex));
          current = current.substring(slashIndex + 1);
        }
        else {
          xPaths.add(current);
          current = null;
        }
      } else {
        xPaths.add(current);
        current = null;
      }
    }
    
    parts = xPaths.toArray(new String[] {""});
  }

  public String getElementName() {
    if (getType() == Node.ATTRIBUTE_NODE) { 
      return parts[parts.length - 2];  
    }

    return parts[parts.length - 1];
  }

  public String getName() {
    if (getType() == Node.ATTRIBUTE_NODE) { 
      return parts[parts.length - 1].substring(1); 
    }

    return parts[parts.length - 1];
  }

  public String getNameWithoutPredicates() {
    return removePredicates(getName());
  }

  public XPath getParent() {
    String parentXPath = "";

    for (int i = 0; i < (parts.length - 1); i++) {
      if (i > 0) {
        parentXPath = parentXPath + "/";
      }
      parentXPath = parentXPath + parts[i];
    }

    return new XPath(parentXPath);
  }

  public short getType() {
    if (parts[parts.length - 1].indexOf("@") == 0) { 
      return Node.ATTRIBUTE_NODE; 
    }

    return Node.ELEMENT_NODE;
  }

  public String removePredicates(String s) {
    int index = s.indexOf("[");

    if (index >= 0) { return s.substring(0, index); }

    return s;
  }

  public String toString() {
    return xpath;
  }
}