package com.capgemini.nemmco.b2bb.validators;

import com.capgemini.nemmco.b2bb.PTPDataExchange;
import com.capgemini.nemmco.b2bb.Transaction;
import com.capgemini.nemmco.b2bb.exceptions.TransactionNotSetException;
import com.capgemini.nemmco.b2bb.utils.BasicValidationUtility;
import org.apache.commons.lang3.StringUtils;

public class PTPDataExchangeBasicValidator extends Validator {
    private PTPDataExchange transaction = null;
    BasicValidationUtility validator = null;

    /**
     * Default constructor
     *
     * @param transaction The transaction to set
     */
    public PTPDataExchangeBasicValidator(Transaction transaction) {
        super(transaction);
        this.transaction = (PTPDataExchange) transaction;
        this.validator = BasicValidationUtility.getBasicInstance();
    }

    @Override
    /**
     *
     * @return Returns true if transaction is valid
     */ public boolean validate() {

        // Move the first element Name and type should be empty

        return validateTransactionID() & validateTransactionDate()
                & validateFreeFormData()
                & ( transaction.getFormat().equals("") || validator.validateEmptyField(events, category, PTPDataExchange.FORMAT, transaction.getFormat()) )
                & ( transaction.getContextID().equals("") || validator.validateEmptyField(events, category, PTPDataExchange.CONTECT_ID, transaction.getContextID()) )
                & ( transaction.getOther().equals("") || validator.validateEmptyField(events, category, PTPDataExchange.OTHER, transaction.getOther()) )
                & validator.validateXmlString(events, category, PTPDataExchange.FORMAT, transaction.getFormat(), 0, 30)

                & validator.validateXmlString(events, category, PTPDataExchange.CONTECT_ID, transaction.getContextID(), 0, 30)

                & validator.validateXmlString(events, category, PTPDataExchange.OTHER, transaction.getOther(), 0, 30);

    }




    /**
     * @return Returns true if freeFormData is valid
     */
    private boolean validateFreeFormData() {
        //Any type allowed
        return true;
    }

    /**
     * @return Returns true if attachmentType1 is valid
     */

    /**
     * @return Returns true if attachmentType2 is valid
     */

    /**
     * @return Returns true if attachmentType\3 is valid
     */

}

