/*
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/validators/SORCancelBasicValidator.java-arc   1.2   Sep 15 2005 15:16:18   adij  $
 * $Revision:   1.2  $
 * $Date:   Sep 15 2005 15:16:18  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 */

package com.capgemini.nemmco.b2bb.validators;

import com.capgemini.nemmco.b2bb.ServiceOrderRequest;
import com.capgemini.nemmco.b2bb.Transaction;
import com.capgemini.nemmco.b2bb.enums.TrueFalse;
import com.capgemini.nemmco.b2bb.enums.ValidationSetting;
import com.capgemini.nemmco.b2bb.enums.EventCode;
import com.capgemini.nemmco.b2bb.exceptions.TransactionNotSetException;
import com.capgemini.nemmco.b2bb.utils.BasicValidationUtility;
import com.capgemini.nemmco.b2bb.lookup.ScreenName;
import com.capgemini.nemmco.b2bb.exceptions.UnableToLookupResourceException;

/**
 * @author $Author:   adij  $
 * @version $Revision:   1.2  $ $Date:   Sep 15 2005 15:16:18  $
 */


public class SORCancelBasicValidator extends ServiceOrderRequestBasicValidator
{

  private BasicValidationUtility validator = null;
  
  public SORCancelBasicValidator(Transaction trans)
  {
    super(trans);
    validator = BasicValidationUtility.getBasicInstance();
  }
  
  
  protected boolean validateActionType() { return validateActionType(ValidationSetting.MANDATORY); }
  protected boolean validateRetServiceOrder() { return validateRetServiceOrder(ValidationSetting.MANDATORY); }
  protected boolean validateNMI() {
    // check if both NMI and Address exist.
    if (validator.exists(transaction.getNMI()) && validator.exists(transaction.getServiceOrderAddress())){
      // show an error since you can only have 1 or the other
      validator.addConcurrencyError(events,category,ServiceOrderRequest.NMI_FIELD,ServiceOrderRequest.SERVICE_ORDER_ADDRESS);
      return false;
    }
	//Must have at last one
    if (!validator.exists(transaction.getNMI()) && !validator.exists(transaction.getServiceOrderAddress())){
		String[] fieldnames = new String[] {ServiceOrderRequest.NMI_FIELD, ServiceOrderRequest.SERVICE_ORDER_ADDRESS};
      try {
        String choices = "[";
        for (int i = 0; i < fieldnames.length; i++) {
          choices += ScreenName.getScreenName(category, fieldnames[i]);
          if (i < fieldnames.length - 1)
            choices += ", ";
        }
        choices += "]";
        validator.addEvent(events, category, fieldnames[0], new String[]{choices}, EventCode.CODE_0201, "invalidChoiceMandatory");
      } catch (UnableToLookupResourceException e)
      {
        validator.unexpectedException(events, fieldnames[0], e.getMessage());
      }
      return false;
	}
  	return validateNMI(ValidationSetting.OPTIONAL);
  }
  protected boolean validateNMIChecksum() { return validateNMIChecksum(ValidationSetting.OPTIONAL); }
  protected boolean validateServiceOrderAddress() { return validateServiceOrderAddress(ValidationSetting.OPTIONAL); }
  protected boolean validateRequestData() { return validateRequestData(ValidationSetting.MANDATORY); }
}

