/*
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/validators/SORMiscellaneousBasicValidator.java-arc   1.5   06 May 2005 15:16:16   RayanS  $
 * $Revision:   1.5  $
 * $Date:   06 May 2005 15:16:16  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * 
 * Defect 4300 : 08-05-07 : EG : Change SafetyCertificateMethodSent to mandatory if SafetyCertificateId has been entered.
 * 
 * Modification History
 * 
 * Date Changed   Changed By        Comments
 * ------------   ----------        -----------
 * 21-Aug-2008    Bob Jones         Defect 4985 - increase each telephone number from one to three.
 */

package com.capgemini.nemmco.b2bb.validators;

import com.capgemini.nemmco.b2bb.Transaction;
import com.capgemini.nemmco.b2bb.enums.ValidationSetting;
import com.capgemini.nemmco.b2bb.utils.BasicValidationUtility;

/**
 * @author $Author:   RayanS  $
 * @version $Revision:   1.5  $ $Date:   06 May 2005 15:16:16  $
 */

public class SORMiscellaneousBasicValidator extends ServiceOrderRequestBasicValidator
{

  private BasicValidationUtility validator = null;
  
  public SORMiscellaneousBasicValidator(Transaction trans)
  {
    super(trans);
    validator = BasicValidationUtility.getBasicInstance();
  }

  //Explicitly define all validations
  //This is listed in the order as prescribed in the B2B procedures
  protected boolean validateActionType() { return validateActionType(ValidationSetting.MANDATORY); }
  protected boolean validateRetServiceOrder() { return validateRetServiceOrder(ValidationSetting.MANDATORY); }
  protected boolean validateNotifyParty() { return validateNotifyParty(ValidationSetting.OPTIONAL); }
  protected boolean validateServiceOrderType() { return validateServiceOrderType(ValidationSetting.MANDATORY); }
  protected boolean validateServiceOrderSubType() { return validateServiceOrderSubType(ValidationSetting.SKIPPED); }
  protected boolean validateDeenergisationReason() { return validateDeenergisationReason(ValidationSetting.SKIPPED); }
  protected boolean validateConfirmDeenergisation() { return validateConfirmDeenergisation(ValidationSetting.SKIPPED); }
  protected boolean validateServiceTime() { return validateServiceTime(ValidationSetting.MANDATORY); }
  protected boolean validateNMI() { return validateNMI(ValidationSetting.MANDATORY); }
  protected boolean validateNMIChecksum() { return validateNMIChecksum(ValidationSetting.OPTIONAL); }
  protected boolean validateMeterSerialNumber() { return validateMeterSerialNumber(ValidationSetting.OPTIONAL); }
  protected boolean validateServiceOrderAddress() { return validateServiceOrderAddress(ValidationSetting.SKIPPED); }
  protected boolean validateHazardDescription1() { return validateHazardDescription1(ValidationSetting.OPTIONAL); }
  protected boolean validateHazardDescription2() { return validateHazardDescription2(ValidationSetting.OPTIONAL); }
  protected boolean validateHazardDescription3() { return validateHazardDescription3(ValidationSetting.OPTIONAL); }
  protected boolean validateAccessDetails() { return validateAccessDetails(ValidationSetting.MANDATORY); }
  protected boolean validateLifeSupport() { return validateLifeSupport(ValidationSetting.MANDATORY); }
  protected boolean validateFormReference() { return validateFormReference(ValidationSetting.OPTIONAL); }
  protected boolean validateFormNumber() { return validateFormNumber(ValidationSetting.OPTIONAL); }
  protected boolean validateSafetyCertificateId() { return validateSafetyCertificateId(ValidationSetting.OPTIONAL); }
  protected boolean validateSafetyCertificateIdMethodSent() { return validateSafetyCertificateIdMethodSent(ValidationSetting.OPTIONAL); }
  protected boolean validateMeteringSafetyCertificateId() { return validateMeteringSafetyCertificateId(ValidationSetting.OPTIONAL); }
  protected boolean validateMeteringSafetyCertificateMethodSent() { return validateMeteringSafetyCertificateMethodSent(ValidationSetting.OPTIONAL); }
  protected boolean validateSpecialInstructions1() { return validateSpecialInstructions1(ValidationSetting.OPTIONAL); } //Conditional Mandatory
  protected boolean validateSpecialInstructions2() { return validateSpecialInstructions2(ValidationSetting.OPTIONAL); }
  protected boolean validateSpecialInstructions3() { return validateSpecialInstructions3(ValidationSetting.OPTIONAL); }
  protected boolean validateCoOrdinationRequired() { return validateCoOrdinationRequired(ValidationSetting.SKIPPED); }
  protected boolean validateCoOrdinatingContactName() { return validateCoOrdinatingContactName(ValidationSetting.SKIPPED); }  //Conditional Mandatory
  protected boolean validateCoOrdinatingContactPhone1() { return validateCoOrdinatingContactPhone1(ValidationSetting.SKIPPED); }  //Conditional Mandatory
  protected boolean validateCoOrdinatingContactPhone2() { return validateCoOrdinatingContactPhone2(ValidationSetting.SKIPPED); }
  protected boolean validateCoOrdinatingContactPhone3() { return validateCoOrdinatingContactPhone3(ValidationSetting.SKIPPED); }
  protected boolean validateCustomerConsultationRequired() { return validateCustomerConsultationRequired(ValidationSetting.MANDATORY); }
  protected boolean validateContactName() { return validateContactName(ValidationSetting.OPTIONAL); }  //Conditional Mandatory
  protected boolean validateContactPhone1() { return validateContactPhone1(ValidationSetting.OPTIONAL); }  //Conditional Mandatory
  protected boolean validateContactPhone2() { return validateContactPhone2(ValidationSetting.OPTIONAL); }
  protected boolean validateContactPhone3() { return validateContactPhone3(ValidationSetting.OPTIONAL); }
  protected boolean validateRetailerName() { return validateRetailerName(ValidationSetting.OPTIONAL); }
  protected boolean validateRetailerPhone1() { return validateRetailerPhone1(ValidationSetting.OPTIONAL); } //Conditional Mandatory
  protected boolean validateRetailerPhone2() { return validateRetailerPhone2(ValidationSetting.OPTIONAL); }
  protected boolean validateRetailerPhone3() { return validateRetailerPhone3(ValidationSetting.OPTIONAL); }
  protected boolean validateScheduleDate() { return validateScheduleDate(ValidationSetting.MANDATORY); }
  protected boolean validateAppointmentReference() { return validateAppointmentReference(ValidationSetting.OPTIONAL); }
  protected boolean validatePreferredDate() { return validatePreferredDate(ValidationSetting.OPTIONAL); }
  protected boolean validatePreferredTime() { return validatePreferredTime(ValidationSetting.OPTIONAL); }
  protected boolean validateRoleAssignments() { return validateRoleAssignments(ValidationSetting.SKIPPED); }
  protected boolean validateNMIStatusCode() { return validateNMIStatusCode(ValidationSetting.OPTIONAL); }
  protected boolean validateEmbeddedNetworkParentName() { return validateEmbeddedNetworkParentName(ValidationSetting.SKIPPED); }
  protected boolean validateCustomerType() { return validateCustomerType(ValidationSetting.OPTIONAL); }
  protected boolean validateAverageDailyLoad() { return validateAverageDailyLoad(ValidationSetting.OPTIONAL); }
  protected boolean validateMaximumDemand() { return validateMaximumDemand(ValidationSetting.OPTIONAL); }
  protected boolean validateLicenseeName() { return validateLicenseeName(ValidationSetting.OPTIONAL); }
  protected boolean validateLicenseeBusinessName() { return validateLicenseeBusinessName(ValidationSetting.OPTIONAL); }
  protected boolean validateLicenseePhone1() { return validateLicenseePhone1(ValidationSetting.OPTIONAL); }
  protected boolean validateLicenseePhone2() { return validateLicenseePhone2(ValidationSetting.OPTIONAL); }
  protected boolean validateLicenseePhone3() { return validateLicenseePhone3(ValidationSetting.OPTIONAL); }
  protected boolean validateRecId() { return validateRecId(ValidationSetting.OPTIONAL); }
  protected boolean validateRECAttendanceRequired() { return validateRECAttendanceRequired(ValidationSetting.OPTIONAL); }
  protected boolean validateInstallationType() { return validateInstallationType(ValidationSetting.OPTIONAL); }
  protected boolean validateSupplyPhases() { return validateSupplyPhases(ValidationSetting.OPTIONAL); }
  protected boolean validateMeteringRequired() { return validateMeteringRequired(ValidationSetting.OPTIONAL); }
  protected boolean validateOffPeakRequirement1() { return validateOffPeakRequirement1(ValidationSetting.OPTIONAL); }
  protected boolean validateOffPeakRequirement2() { return validateOffPeakRequirement2(ValidationSetting.OPTIONAL); }
  protected boolean validateOffPeakRequirement3() { return validateOffPeakRequirement3(ValidationSetting.OPTIONAL); }
  protected boolean validateMeterInstallCode() { return validateMeterInstallCode(ValidationSetting.OPTIONAL); }
  protected boolean validateSwitchingServiceRequired() { return validateSwitchingServiceRequired(ValidationSetting.OPTIONAL); }
  protected boolean validateProposedTariff() { return validateProposedTariff(ValidationSetting.SKIPPED); }
  protected boolean validateProposedTariff1() { return validateProposedTariff1(ValidationSetting.OPTIONAL); }
  protected boolean validateProposedTariff2() { return validateProposedTariff2(ValidationSetting.OPTIONAL); }
  protected boolean validateProposedTariff3() { return validateProposedTariff3(ValidationSetting.OPTIONAL); }

  protected boolean validateRequestData() { return validateRequestData(ValidationSetting.SKIPPED); }
 
  
}

