/*
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/validators/SiteAddressNotificationBasicValidator.java-arc   1.13   11 Apr 2005 13:43:16   hendyl  $
 * $Revision:   1.13  $
 * $Date:   11 Apr 2005 13:43:16  $
 *
 * Copyright 2005 Capgemini Australia Pty. Ltd.
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 */

package com.capgemini.nemmco.b2bb.validators;

import com.capgemini.nemmco.b2bb.SiteAddressNotification;
import com.capgemini.nemmco.b2bb.Transaction;
import com.capgemini.nemmco.b2bb.enums.EventCode;
import com.capgemini.nemmco.b2bb.utils.BasicValidationUtility;

/**
 * Basic validator for Site Address Notification transaction
 *
 * @author $Author:   hendyl  $
 * @version $Revision:   1.13  $ $Date:   11 Apr 2005 13:43:16  $
 */
public class SiteAddressNotificationBasicValidator extends Validator {
  BasicValidationUtility validator = null;
  private SiteAddressNotification transaction = null;
  private String transactionType = "";

  /**
   * Default constructor
   * @param trans The transaction to set
   */
  public SiteAddressNotificationBasicValidator(Transaction trans) {
    super(trans);
    transaction = (SiteAddressNotification) trans;
    transactionType = transaction.getTransactionType().getCode();
    validator = BasicValidationUtility.getBasicInstance();
  }

  /**
   * 
   * @return Returns true if transaction is valid, false otherwise
   */
  public boolean validate() {
    boolean result = true;

    result = validateTransactionID() && result;
    result = validateTransactionDate() && result;
    result = validateNMI() && result;
    result = validateNMIChecksum() && result;
    result = validateLastModifiedDateTime() && result;
    result = validateAddress() && result;

    return result;
  }

  /**
   * 
   * @return Returns true if address object is valid
   */
  protected boolean validateAddress() {
    try {
      String fieldname = SiteAddressNotification.ADDRESS;
      if (transaction.getAddress() == null) {
        Object[] args = { "Address" };
        validator.addEvent(events, transactionType, fieldname, args, EventCode.CODE_0201, "invalidXMLFile");
        return false;
      } else {
        Address address = transaction.getAddress();
        address.setEvents(events);

        address.setParentCategory(category);
        address.setParentField(fieldname);
        boolean result = address.validate();

        return result;
      }
    } catch (Exception e) {
      return false;
    }
  }

  /**
   * 
   * @return Returns true if lastModifiedDateTime is valid
   */
  protected boolean validateLastModifiedDateTime() {
    String field = SiteAddressNotification.LAST_MODIFIED_DATETIME;

    if (transaction.isLastModifiedDateTimeSet()) {
      return validator.validateMandatory(events, category, field, transaction.getLastModifiedDateTime())
          && validator.validateXMLDateTime(events, category, field, transaction.getLastModifiedDateTime());
    } else {
      return validator.validateMandatory(events, category, field, transaction.getLastModifiedDisplayDateTime())
          && validator.validateB2BDateTime(events, category, field, transaction.getLastModifiedDisplayDateTime());
    }
  }
}

