/*
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/validators/TransactionAcknowledgementBasicValidator.java-arc   1.1   11 Apr 2005 11:11:10   RayanS  $
 * $Revision:   1.1  $
 * $Date:   11 Apr 2005 11:11:10  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 */

package com.capgemini.nemmco.b2bb.validators;

import com.capgemini.nemmco.b2bb.TransactionAcknowledgement;
import com.capgemini.nemmco.b2bb.XMLObject;
import com.capgemini.nemmco.b2bb.exceptions.TransactionNotSetException;

/**
 * The class <code>AcknowledgementBasicValidator</code> is the Basic Validator 
 * object of the Acknowledgement.
 * 
 * @author $Author:   RayanS  $
 * @version $Revision:   1.1  $ $Date:   11 Apr 2005 11:11:10  $
 */
public class TransactionAcknowledgementBasicValidator extends AcknowledgementBasicValidator {
  protected TransactionAcknowledgement transAck;
  
  /**
   * Constructor. Sets a transaction with the objects initialisation.
   * @param transAck Transaction to use in the validator.
   */
  public TransactionAcknowledgementBasicValidator(XMLObject transAck) {
    super(transAck);
    this.transAck = (TransactionAcknowledgement) transAck;
  }

  /**
   * Validate the Transaction
   * 
   * @return boolean result of validation
   */
  public boolean validate() {
    boolean result = true;
    result &= super.validate() 
        & validateInitiatingTransactionID();

    return result;
  }

  protected boolean validateInitiatingTransactionID() {
    String field = TransactionAcknowledgement.INIT_TRANS_ID;
    return validator.validateMandatory(events, category, field, transAck.getInitiatingTransactionID())
        & validator.validateTransactionId(events, category, field, transAck.getInitiatingTransactionID());
  }
}

