/**
 * $Header:   //cardsrc1/pvcs/B2B_BROWSER/archives/src/com/capgemini/nemmco/b2bb/validators/ValidatorInterface.java-arc   1.0   Mar 21 2005 08:57:56   adij  $
 * $Revision:   1.0  $
 * $Date:   Mar 21 2005 08:57:56  $
 * 
 * Copyright 2005 Capgemini Australia Pty. Ltd. 
 * All rights reserved.
 * NEMMCO CONFIDENTIAL.
 * Date Changed   Changed By     Comments
 * ------------   ----------     -----------
 * 14-Aug-2012    Bob Jones      7984 Java upgrade from 6 to 7.
 */

package com.capgemini.nemmco.b2bb.validators;

import java.util.List;

import com.capgemini.nemmco.b2bb.utils.EventObject;

import com.capgemini.nemmco.b2bb.exceptions.XMLObjectNotSetException;

/**
 * The class <code>Validator</code> is the parent Validator object for all
 * transaction validators.
 *
 * @author $Author:   adij  $
 * @version $Revision:   1.0  $ $Date:   Mar 21 2005 08:57:56  $
 */
public interface ValidatorInterface {

  /**
   * 
   * @return a list of events which were encountered while validating
   * the Transaction. A Blank list is returned if no events are found. null
   * is returned if validate has not yet been called.
   */
  public List<EventObject> getEvents();
  
  /**
   * Called to validate the XMLObject.
   * 
   * @throws XMLObjectNotSetException if a transaction has not yet been set.
   */
  public abstract boolean validate() throws XMLObjectNotSetException;

}

